/*
 *
 * MINIGUI - Harbour Win32 GUI library
 * Copyright 2002-2009 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * Program to view DBF files using standard Browse control
 * Miguel Angel Jurez A. - 2009 MigSoft <mig2soft/at/yahoo.com>
 * Includes the code of Grigory Filatov <gfilatov@freemail.ru>
 * and Rathinagiri <srathinagiri@gmail.com>
 *
 */

#include 'minigui.ch'
#include "dbview.ch"

PROCEDURE AdministraDBF(cBase,nReg)

Public Nuevo := .F., aName := {}, aCtrol := {}, nOpt := 1 , nReg1:=nReg

   If !Empty( Alias() )

       nAlto := CalcHeight()

       DEFINE WINDOW Win_2                                ;
           AT 0,0                                         ;
           WIDTH 685                                      ;
           HEIGHT 525                                     ;
           TITLE PROGRAM+VERSION+' - Record View'         ;
           ICON "MAIN"                                    ;
           MODAL                                          ;
           FONT 'ARIAL' SIZE 9                            ;
           ON INIT ( DesactivarEdicion(), Actualizar2() ) ;
           ON RELEASE CerrarTablas()

           AbrirTablas()

           Define Splitbox

               MyToolBar()

               Define Window Win_1                          ;
                   width 650                                ;
                   height 450                               ;
                   virtual height MAX(nAlto-70,451)         ;
                   splitchild                               ;
                   nocaption                                ;
                   font "ms sans serif" size 9              ;
                   focused

                   CreaControles()

                   @  70,500 BUTTON ACEPTAR  CAPTION 'O&K'     ACTION AceptarEdicion()
                   @ 100,500 BUTTON CANCELAR CAPTION 'Ca&ncel' ACTION CancelarEdicion()

               End Window

           End Splitbox

       END WINDOW

       CENTER WINDOW Win_2
       ACTIVATE WINDOW Win_2

   Endif

RETURN

*------------------------------------------------------------*
Function CalcHeight()
*------------------------------------------------------------*
   nAlto1 := 140

   For n := 1 to Fcount()
       If ValType(&(Fieldname(n)))=='M'
          nAlto1 := nAlto1 + 58
       Endif
   Next

   nAlto1 := nAlto1 + ( FCount() * 30 )

Return(nAlto1)

*------------------------------------------------------------*
PROCEDURE CreaControles()
*------------------------------------------------------------*
   nFil := 10

   @ nFil,10 FRAME FRAME_1 WIDTH 620 HEIGHT MAX(nAlto - 90, 138)

   aLabel := {}  ; aCtrol := {} ; aName := {}

   aDBstru  := DBstruct()

   For n := 1 to FCount()

       aadd( aLabel , "label_" + alltrim( str(n) ) )
       aadd( aCtrol , "Control_" + alltrim( str(n) ) )
       aadd( aName  , Fieldname(n) )
       nLongTot := aDBstru[n,3] ; nLongDec := aDBstru[n,4]
       @ nFil+(n*30),20 LABEL &(aLabel[n]) VALUE aName[n]+" ("+alltrim(str(nLongTot,6,0))+")" WIDTH 80

       If ValType(&(aName[n]))=='L'
          @ nFil+(n*30) ,150 CHECKBOX   &(aCtrol[n]) caption "Yes" value &(aName[n])
       Elseif ValType(&(aName[n]))=='D'
          @ nFil+(n*30) ,150 DATEPICKER &(aCtrol[n]) value &(aName[n]) UpDown SHOWNONE
       Elseif ValType(&(aName[n]))=='N'
          cInpMsk  := iif( nLongDec > 0, REPLICATE( "9", nLongTot - nLongDec -1 ) + "." + REPLICATE( "9", nLongDec ), REPLICATE( "9", nLongTot - nLongDec ) )
          nWidthF  := Min( iif(len(str(&(aName[n])))*10<40,40,len(str(&(aName[n])))*10),300 )
          @ nFil+(n*30) ,150 TEXTBOX &(aCtrol[n]) WIDTH nWidthF VALUE &(aName[n]) NUMERIC INPUTMASK cInpMsk RIGHTALIGN
       Elseif ValType(&(aName[n]))=='C'
          @ nFil+(n*30) ,150 TEXTBOX    &(aCtrol[n]) value &(aName[n]) width Min( iif(len(&(aName[n]))*10<40,40,len(&(aName[n]))*10),300 )
       Elseif ValType(&(aName[n]))=='M'
          @ nFil+(n*30) ,150 EDITBOX    &(aCtrol[n]) value &(aName[n]) width 300 height 81
          nFil := nFil + 58
       Endif

   Next

Return

*------------------------------------------------------------*
PROCEDURE MyToolbar()
*------------------------------------------------------------*

   DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 24,24 FONT "Arial" SIZE 9 FLAT //BORDER RIGHTTEXT

      BUTTON PRIMERO TOOLTIP '&First' PICTURE 'first1'	;
      ACTION ( dBGoTop() ,Actualizar2() )

      BUTTON ANTERIOR TOOLTIP '&Previous' PICTURE 'previous1'	;
      ACTION ( dBSkip ( -1 ),Actualizar2() )

      BUTTON SIGUIENTE TOOLTIP '&Next' PICTURE 'next1'	;
      ACTION ( dBSkip (1) , if ( Eof() , DbGoBottom() , Nil ) ,Actualizar2() )

      BUTTON ULTIMO TOOLTIP '&Last' PICTURE 'last1'	;
      ACTION ( dBGoBottom (),Actualizar2()  )  SEPARATOR

      BUTTON BUSCAR TOOLTIP '&Find' PICTURE 'find1'	;
      ACTION Buscando()

      BUTTON Nuevo TOOLTIP '&New' PICTURE 'new1'	;
      ACTION ( Nuevo := .T. , Nuevo() )

      BUTTON EDITAR TOOLTIP '&Edit' PICTURE 'format1'	;
      ACTION If ( BloquearRegistro() , ActivarEdicion() , Nil )

      BUTTON ELIMINAR TOOLTIP 'E&rase' PICTURE 'erase1'	;
      ACTION Eliminar()

      BUTTON IMPRIMIR TOOLTIP '&Print'PICTURE 'print1' ;
      ACTION Imprimir()

      BUTTON CERRAR TOOLTIP '&Close' PICTURE 'record1' ;
      ACTION Win_2.release

   END TOOLBAR

RETURN

*------------------------------------------------------------*
PROCEDURE Buscando()
*------------------------------------------------------------*
If !Empty( Alias() )

   nAlto := CalcHeight()

   DEFINE WINDOW Win_Busca2                           ;
       AT 0,0                                         ;
       WIDTH 685                                      ;
       HEIGHT 493                                     ;
       TITLE PROGRAM+VERSION+' - Record Find'         ;
       ICON "MAIN"                                    ;
       MODAL                                          ;
       FONT 'ARIAL' SIZE 9

       Define Splitbox

           Define Window Win_Busca1                    ;
              width 650                                ;
              height 450                               ;
              virtual height MAX(nAlto-70,451)         ;
              splitchild                               ;
              nocaption                                ;
              font "ms sans serif" size 9              ;
              focused

              CreaControles()
              Nuevo2()

              @  70,500 BUTTON ACEPTAR  CAPTION 'O&K'     ACTION AceptaBuscar()
              @ 100,500 BUTTON CANCELAR CAPTION 'Ca&ncel' ACTION CancelaBuscar()

           End Window

       End Splitbox

    END WINDOW

    CENTER WINDOW Win_Busca2
    ACTIVATE WINDOW Win_Busca2

Endif

Return
*------------------------------------------------------------*
PROCEDURE AbrirTablas
*------------------------------------------------------------*

   Go nReg1

RETURN
*------------------------------------------------------------*
PROCEDURE CerrarTablas
*------------------------------------------------------------*

RETURN
*------------------------------------------------------------*
PROCEDURE DesactivarEdicion
*------------------------------------------------------------*

For n := 1 to FCount()
    Win_1.&(aCtrol[n]).Enabled	  := .F.
Next

Win_1.Aceptar.Enabled		:= .F.
Win_1.Cancelar.Enabled		:= .F.
Win_2.ToolBar_1.Enabled		:= .T.

RETURN
*------------------------------------------------------------*
PROCEDURE ActivarEdicion
*------------------------------------------------------------*

For n := 1 to FCount()
    Win_1.&(aCtrol[n]).Enabled	  := .T.
Next

Win_1.Aceptar.Enabled		:= .T.
Win_1.Cancelar.Enabled		:= .T.
Win_2.ToolBar_1.Enabled		:= .F.

Win_1.&(aCtrol[1]).SetFocus

RETURN
*------------------------------------------------------------*
PROCEDURE CancelarEdicion()
*------------------------------------------------------------*

DesactivarEdicion()

Actualizar2()

( Alias() )->( dbUnlock() )

Nuevo := .F.

RETURN
*------------------------------------------------------------*
PROCEDURE AceptarEdicion()
*------------------------------------------------------------*

   DesactivarEdicion()

   If Nuevo == .T.
      (Alias())->(DbAppend())
      Nuevo := .F.
   EndIf

   For n := 1 to FCount()
       (Alias())->&(aName[n]) := Win_1.&(aCtrol[n]).Value
   Next

   UNLOCK

RETURN

*------------------------------------------------------------*
PROCEDURE CancelaBuscar()
*------------------------------------------------------------*

    Win_Busca2.Release

RETURN

*------------------------------------------------------------*
PROCEDURE AceptaBuscar()
*------------------------------------------------------------*

   For n := 1 to FCount()
       If !Empty( Win_Busca1.&(aCtrol[n]).Value )
           Busca := Win_Busca1.&(aCtrol[n]).Value
           cNomb := FieldName(n)
           Locate for &( cNomb ) = ( Busca )
           If Found()
              nRegBus := (Alias())->(Recno())
              Go nRegBus
              Actualizar2()
           Else
              MsgExclamation( 'No records for your query!', PROGRAM )
           EndIf
           Win_Busca2.Release
       Endif
   Next

Return
*------------------------------------------------------------*
PROCEDURE Nuevo()
*------------------------------------------------------------*

   For n := 1 to FCount()
       aadd( aCtrol , "Control_" + alltrim( str(n) ) )
       aadd( aName  , Fieldname(n) )

       If ValType(&(aName[n]))=='L'
          Win_1.&(aCtrol[n]).value := .F.
       Elseif ValType(&(aName[n]))=='D'
          Win_1.&(aCtrol[n]).value := ctod("  /  /  ")
       Elseif ValType(&(aName[n]))=='N'
          Win_1.&(aCtrol[n]).value := 0
       Elseif ValType(&(aName[n]))=='C'
          Win_1.&(aCtrol[n]).value := ''
       Elseif ValType(&(aName[n]))=='M'
          Win_1.&(aCtrol[n]).value := ''
       Endif
   Next

ActivarEdicion()

RETURN

*------------------------------------------------------------*
PROCEDURE Nuevo2()
*------------------------------------------------------------*

   For n := 1 to FCount()
       aadd( aCtrol , "Control_" + alltrim( str(n) ) )
       aadd( aName  , Fieldname(n) )

       If ValType(&(aName[n]))=='L'
          Win_Busca1.&(aCtrol[n]).value := .F.
       Elseif ValType(&(aName[n]))=='D'
          Win_Busca1.&(aCtrol[n]).value := ctod("  /  /  ")
       Elseif ValType(&(aName[n]))=='N'
          Win_Busca1.&(aCtrol[n]).value := 0
       Elseif ValType(&(aName[n]))=='C'
          Win_Busca1.&(aCtrol[n]).value := ''
       Elseif ValType(&(aName[n]))=='M'
          Win_Busca1.&(aCtrol[n]).value := ''
       Endif
   Next

RETURN

*------------------------------------------------------------*
PROCEDURE Actualizar2()
*------------------------------------------------------------*

For n := 1 to FCount()
    Win_1.&(aCtrol[n]).Value := (Alias())->&(aName[n])
Next

Return
*------------------------------------------------------------*
Function BloquearRegistro()
*------------------------------------------------------------*
Local RetVal

If (Alias())->(RLock())
   RetVal := .t.
Else
   MsgExclamation ('This record is edited by another user. Retry Later')
   RetVal := .f.
EndIf

Return RetVal
*------------------------------------------------------------*
Procedure Eliminar
*------------------------------------------------------------*

If MsgYesNo ( 'Are you sure?',PROGRAM)

   If BloquearRegistro()
      (Alias())->(dbdelete())
      (Alias())->(dbgotop())
      Actualizar2()
   EndIf
EndIf

Return
*------------------------------------------------------------*
Procedure Imprimir()
*------------------------------------------------------------*
   Local RecLocat

   RecLocat := (Alias())->(RecNo())

   Select (Alias())

   aHdr1 := array(len(aName))
   aSize := array(len(aName))
   aTot  := array(len(aName))
   afill(aHdr1, '')
   afill(aSize, 10)
   afill(aTot, .F.)

   Go Top

   DO REPORT                    ;
   TITLE    Alias()             ;
   HEADERS  aHdr1 , aName       ;
   FIELDS   aName               ;
   WIDTHS   aSize               ;
   TOTALS   aTot                ;
   WORKAREA &(Alias())          ;
   LPP 60                       ;
   CPL 120                      ;
   LMARGIN 3                    ;
   PREVIEW

(Alias())->(DbGoTo(RecLocat))

Return
