/*
 *
 * MINIGUI - Harbour Win32 GUI library
 * Copyright 2002-2009 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * Program to view DBF files using standard Browse control
 * Miguel Angel Jurez A. - 2009 MigSoft <mig2soft/at/yahoo.com>
 * Includes the code of Grigory Filatov <gfilatov@freemail.ru>
 * and Rathinagiri <srathinagiri@gmail.com>
 *
 */

#include "minigui.ch"
#include "dbview.ch"

*--------------------------------------------------------*
Procedure ShowProperties()
*--------------------------------------------------------*
   Local aNames := {}, data_type := { "Character", "Numeric", "Date", "Logical", "Memo" }

   If !Empty( Alias() )
   declare window form_prop
   Aeval( (Alias())->( DBstruct() ), ;
        {|e,i| aadd(aNames, { Str(i, 4), e[1], data_type[ AT(e[2], "CNDLM") ], Ltrim(Str(e[3])), Ltrim(Str(e[4])) })} )

	DEFINE WINDOW Form_Prop ;
		AT 0, 0 WIDTH 390 HEIGHT 450  ;
		TITLE PROGRAM+VERSION+"- DBF Properties" ;
		ICON 'MAIN' ;
		MODAL ;
		ON INIT Form_Prop.Grid_1.Setfocus ;
		FONT "MS Sans Serif" ;
		SIZE 8

    DEFINE FRAME Frame_1
        ROW    10
        COL    10
        WIDTH  360
        HEIGHT 100
        OPAQUE .T.
    END FRAME

    DEFINE LABEL Label_1
        ROW    18
        COL    20
        WIDTH  120
        HEIGHT 21
        VALUE "File:"
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_11
        ROW    18
        COL    80
        WIDTH  266
        HEIGHT 42
        VALUE  ALLTRIM(aNewfile[1])
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_2
        ROW    46
        COL    20
        WIDTH  120
        HEIGHT 21
        VALUE "Size:"
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_22
        ROW    46
        COL    80
        WIDTH  120
        HEIGHT 21
        VALUE ALLTRIM(Ltrim(Str(FileSize(aNewfile[1])))) + " " + "Byte(s)"
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_3
        ROW    66
        COL    20
        WIDTH  120
        HEIGHT 21
        VALUE "Created:"
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_33
        ROW    66
        COL    80
        WIDTH  120
        HEIGHT 21
        VALUE DtoC( (Alias())->( LupDate() ) )
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_4
        ROW    86
        COL    20
        WIDTH  120
        HEIGHT 21
        VALUE "Modified:"
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_44
        ROW    86
        COL    80
        WIDTH  120
        HEIGHT 21
        VALUE DtoC(FileDate(aNewfile[1])) + "  " + FileTime(aNewfile[1])
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE FRAME Frame_2
        ROW    116
        COL    10
        WIDTH  360
        HEIGHT 90
        OPAQUE .T.
    END FRAME

    DEFINE LABEL Label_5
        ROW    122
        COL    20
        WIDTH  120
        HEIGHT 21
        VALUE "Number of Records:"
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_55
        ROW    122
        COL    160
        WIDTH  120
        HEIGHT 21
        VALUE Ltrim(Str((Alias())->( LastRec() )))
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_6
        ROW    142
        COL    20
        WIDTH  120
        HEIGHT 21
        VALUE "Header Size:"
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_66
        ROW    142
        COL    160
        WIDTH  120
        HEIGHT 21
        VALUE Ltrim(Str((Alias())->( Header() )))
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_7
        ROW    162
        COL    20
        WIDTH  120
        HEIGHT 21
        VALUE "Record Size:"
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_77
        ROW    162
        COL    160
        WIDTH  120
        HEIGHT 21
        VALUE Ltrim(Str((Alias())->( RecSize() )))
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_8
        ROW    182
        COL    20
        WIDTH  120
        HEIGHT 21
        VALUE "Number of Fields:"
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE LABEL Label_88
        ROW    182
        COL    160
        WIDTH  120
        HEIGHT 21
        VALUE Ltrim(Str((Alias())->( Fcount() )))
        VISIBLE .T.
        AUTOSIZE .F.
    END LABEL

    DEFINE GRID Grid_1
        ROW    212
        COL    10
        WIDTH  360
        HEIGHT 150
        ITEMS aNames
        VALUE 0
        WIDTHS { 27, 120, 72, 50, 40 }
        HEADERS {' #', ' Name', 'Type', ' Len', ' Dec'}
        NOLINES .T.
        JUSTIFY { BROWSE_JTFY_LEFT, BROWSE_JTFY_LEFT, BROWSE_JTFY_LEFT, BROWSE_JTFY_RIGHT, BROWSE_JTFY_RIGHT }
    END GRID

    DEFINE BUTTON Button_1
        ROW    380
        COL    280
        WIDTH  80
        HEIGHT 24
        CAPTION "Close"
        ACTION ( ThisWindow.Release )
        TABSTOP .T.
        VISIBLE .T.
    END BUTTON

        ON KEY ESCAPE ACTION Form_Prop.Button_1.OnClick

	END WINDOW

	CENTER WINDOW Form_Prop

	ACTIVATE WINDOW Form_Prop
   Endif
Return
