/*
 *
 * MINIGUI - Harbour Win32 GUI library
 * Copyright 2002-2009 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * Program to view DBF files using standard Browse control
 * Miguel Angel Jurez A. - 2009 MigSoft <mig2soft/at/yahoo.com>
 * Includes the code of Grigory Filatov <gfilatov@freemail.ru>
 * and Rathinagiri <srathinagiri@gmail.com>
 *
 */

#include "minigui.ch"
#include "dbstruct.ch"
#include "fileio.ch"
#include "dbview.ch"

*------------------------------------------------------------------------------*
Function Main( cDBF, ... )
*------------------------------------------------------------------------------*

REQUEST DBFCDX , DBFFPT
RDDSETDEFAULT( "DBFCDX" )

   Publicar()

   Load window oWndBase
   If PCOUNT() > 0
      OpenBase( cDBF )
   Else
      OpenBase( "" )
   Endif

   oWndBase.Center
   oWndBase.Activate

Return Nil
*------------------------------------------------------------------------------*
Procedure Publicar()
*------------------------------------------------------------------------------*

    Public nAltoPantalla  := GetDesktopHeight() + GetTitleHeight() + GetBorderHeight()
    Public nAnchoPantalla := GetDesktopWidth()
    Public nRow           := nAltoPantalla  * 0.10
    Public nCol           := nAnchoPantalla * 0.10
    Public nWidth         := nAnchoPantalla * 0.95
    Public nHeight        := nAltoPantalla  * 0.85
    Public cBaseFolder, aTypes, aNewFile := {}
    Public nCamp, aEst    := {}, aNomb := {}, aJust := {}, aLong := {}, i, cBase
    Public cFont          := 'MS Sans Serif'
    Public nSize          := 8
    Public aFntClr        := {0,0,0}
    Public aBackClr       := {255,255,255}
    Public aSearch        := {}, aReplace := {}
    Public nSearch        := 1, nReplace := 1, nColumns := 1
    Public lMatchCase     := .F., lMatchWhole := .F.
    Public nDirect        := 3, cDateFormat := "DD.MM.YYYY"
    Public _DBULastPath   := '' , _DBUactiveindex
    Public _DBUindexfields:= {}
    Public _DBUindexfiles := {}
    HB_LANGSELECT( "EN" )
    DECLARE WINDOW Form_Query
    DECLARE WINDOW Form_Find
Return
*------------------------------------------------------------------------------*
Procedure OpenBase( cDBF )
*------------------------------------------------------------------------------*

   If IsControlDefined(Tab_1,oWndBase)
      Close data
      oWndBase.Browse_1.release
      oWndBase.Tab_1.release
   Endif

   cBaseFolder := GetStartupFolder()
   LoadArchIni(cBaseFolder+'\')

   IF EMPTY(cDBF) .OR. ValType ( cDBF ) == 'U'
      aTypes     := { {'Database files (*.dbf)', '*.dbf'} }
      aNewFile   := GetFile( aTypes, 'Select database files', cBaseFolder, .T. )
   Else
      aadd( aNewFile , cDBF )
   ENDIF

   IF !Empty(aNewFile)

      Use (aNewFile[1]) New

      _DBULastPath := curdrive()+':\'+CurDir()+'\'

      If !Used(aNewFile[1])
         MsgInfo("Unable open file: "+aNewFile[1],PROGRAM)
      Else
         oWndBase.Title := PROGRAM+VERSION+COPYRIGHT+aNewfile[1]
         cBase := Alias()
         nCamp := Fcount()
         aEst  := DBstruct()
         aNomb := {'iif(deleted(),0,1)'} ; aJust := {0} ; aLong := {0}
         For i := 1 to nCamp
             aadd(aNomb,aEst[i,1])
             aadd(aJust,iif(aEst[i,2]=='N',1,0))
             aadd(aLong,Max(100,Min(160,aEst[i,3]*14)))
         Next
         CreaBrowse( cBase, aNomb, aLong, aJust, .F. )
      Endif
   Else
      cBase := ''
   Endif

Return
*------------------------------------------------------------------------------*
Function CreaBrowse( cBase, aNomb, aLong, aJust, lAutofit )
*------------------------------------------------------------------------------*
    aHdr       := aClone(aNomb)
    aHdr[1]    := ""
    aLong[1]   := 20
    aCabImg    := aClone(VerHeadIcon())

      DEFINE TAB Tab_1 OF oWndBase AT 30,15 WIDTH oWndBase.width  - 38 HEIGHT oWndBase.height - 137 VALUE 1 FONT "Arial" SIZE 9 TOOLTIP "" FLAT  ON CHANGE Nil

          PAGE cBase


               @ 26,0 BROWSE Browse_1 OF oWndBase ;
               WIDTH  oWndBase.width  - 40        ;
               HEIGHT oWndBase.height - 137       ;
               HEADERIMAGE aCabImg                ;
               HEADERS aHdr                       ;
               WIDTHS aLong                       ;
               WORKAREA &cBase                    ;
               FIELDS aNomb                       ;
               JUSTIFY aJust                      ;
               VALUE 0                            ;
               EDIT INPLACE                       ;
               APPEND                             ;
               FONT "MS Sans Serif" SIZE 8        ;
               TOOLTIP ""                         ;
               ON CHANGE MuestraRec(cBase)        ;
               IMAGE { "br_no", "br_ok" }         ;
               LOCK                               ;
               DELETE

          END PAGE

      END TAB

    SetHeaderImages()

Return Nil
*------------------------------------------------------------------------------*
Procedure VerHeadIcon()
*------------------------------------------------------------------------------*

   aName     := {}
   aHeadIcon := {"hdel"}
   For n := 1 to FCount()
       aadd( aName  , Fieldname(n) )
       Do Case
          Case ValType(&(aName[n]))=='L'
               aadd(aHeadIcon,"hlogic")
          Case ValType(&(aName[n]))=='D'
               aadd(aHeadIcon,"hfech")
          Case ValType(&(aName[n]))=='N'
               aadd(aHeadIcon,"hnum")
          Case ValType(&(aName[n]))=='C'
               aadd(aHeadIcon,"hchar")
          Case ValType(&(aName[n]))=='M'
               aadd(aHeadIcon,"hmemo")
       Endcase
   Next

Return(aHeadIcon)
*------------------------------------------------------------------------------*
Function SetHeaderImages()
*------------------------------------------------------------------------------*

   atemp := Array( FCount()+1 )

*   Aeval( atemp, {|x,i| oWndBase.Browse_1.HeaderImage(i) := {i,(aJust[i]==1)}} )

   oWndBase.Browse_1.Fontname  := cFont
   oWndBase.Browse_1.Fontsize  := nSize
   oWndBase.Browse_1.fontcolor := aFntClr
   oWndBase.Browse_1.Backcolor := aBackClr

Return Nil
*------------------------------------------------------------------------------*
Procedure Adjust()
*------------------------------------------------------------------------------*
   If IsControlDefine(browse_1,oWndBase)
      oWndBase.Browse_1.Width  := oWndBase.width  - 40
      oWndBase.Browse_1.Height := oWndBase.height - 137
      oWndBase.Tab_1.width     := oWndBase.width  - 38
      oWndBase.Tab_1.Height    := oWndBase.height - 137
   Endif
Return
*------------------------------------------------------------------------------*
Procedure DeleteRecall()
*------------------------------------------------------------------------------*
   If !Empty( Alias() )
      ( Alias() )->( DbGoto(oWndBase.Browse_1.Value) )

      if ( Alias() )->( Rlock() )
         iif( ( Alias() )->( Deleted() ), ( Alias() )->( DbRecall() ), ( Alias() )->( DbDelete() ) )
         siguiente()
      endif
      ( Alias() )->( dbUnlock() )
      Actualizar()

   Endif
Return
*------------------------------------------------------------------------------*
Procedure MuestraRec(cBase)
*------------------------------------------------------------------------------*
   oWndBase.StatusBar.Item(1) := ' Record: '      ;
   +padl(Alltrim(Str(oWndBase.Browse_1.Value)),5) ;
   +'/'+padl(Alltrim(Str(&cBase->(lastrec()))),5)
Return
*------------------------------------------------------------------------------*
Procedure primero()
*------------------------------------------------------------------------------*
   If !Empty( cbase )
      ( cbase )->( DbGotop() )
      Actualizar()
   Endif
return
*------------------------------------------------------------------------------*
Procedure anterior()
*------------------------------------------------------------------------------*
   If !Empty( cbase )
      ( cbase )->( dBSkip ( -1 ) )
      Actualizar()
   Endif
return
*------------------------------------------------------------------------------*
Procedure siguiente()
*------------------------------------------------------------------------------*
   If !Empty( cbase )
      ( cbase )->( dBSkip (1) )
      if  ( cbase )->( recno() ) = ( cbase )->( LastRec()+1 )
          ( cbase )->( DbGoBottom() )
      endif
      Actualizar()
   Endif
return
*------------------------------------------------------------------------------*
Procedure ultimo()
*------------------------------------------------------------------------------*
   If !Empty( cbase )
      ( cbase )->( dbgobottom() )
*      _BrowseEnd ( "Browse_1" , "oWndBase" )
      Actualizar()
   Endif
return
*------------------------------------------------------------------------------*
Procedure Append()
*------------------------------------------------------------------------------*
   If !Empty( cbase )
      ( cbase )->( DbAppend() )
      oWndBase.Browse_1.Value := ( cbase )->( RecNo() )
      oWndBase.Browse_1.SetFocus
   Endif
Return
*------------------------------------------------------------------------------*
Procedure Edit()
*------------------------------------------------------------------------------*
   If !Empty( cbase )
      ( cbase )->( DbGoto(oWndBase.Browse_1.Value) )
      oWndBase.Browse_1.Value := ( cbase )->( RecNo() )
      oWndBase.Browse_1.SetFocus
   Endif
Return
*------------------------------------------------------------------------------*
Procedure CierraBase()
*------------------------------------------------------------------------------*
   If !Empty( cbase )
      Close data
      oWndBase.Browse_1.release
      oWndBase.Tab_1.release
      OpenBase("")
   Endif
return
*------------------------------------------------------------------------------*
Procedure Actualizar()
*------------------------------------------------------------------------------*
   If !Empty( cbase )
      oWndBase.Browse_1.value := ( cbase )->( Recno() )
      oWndBase.Browse_1.Refresh
      oWndBase.Browse_1.SetFocus
   Endif
Return
*------------------------------------------------------------------------------*
Procedure PackBase()
*------------------------------------------------------------------------------*
   If !Empty( cbase )
      if MsgYesNo("Are you sure Pack Database?",PROGRAM)
         Pack
         Actualizar()
      Endif
   Endif
Return
*------------------------------------------------------------------------------*
Procedure ZapBase()
*------------------------------------------------------------------------------*
   If !Empty( cbase )
      if MsgYesNo("DANGER!! - Are you sure Zap Database?",PROGRAM)
         Zap
         Actualizar()
      Endif
   Endif
Return
*------------------------------------------------------------------------------*
Procedure GoToRecord()
*------------------------------------------------------------------------------*
    Local VamosA
    If !Empty( cbase )
       nUltimo := ( cbase )->( LastRec() )
       VamosA := val(InputBox( 'Goto Record:' , PROGRAM ))
       VamosA := iif(VamosA>nUltimo,nUltimo,VamosA)
       If .Not. Empty(VamosA)
          ( cbase )->( dbgoto(VamosA) )
          Actualizar()
       EndIf
    Endif
Return
*--------------------------------------------------------*
Procedure BackColorBrowse()
*--------------------------------------------------------*
   If IsControlDefine(browse_1,oWndBase)
      aBackClr := GetColor()
      oWndBase.Browse_1.Backcolor := aBackClr
      SaveArchIni(cBaseFolder+'\')
      Actualizar()
   Endif
Return
*--------------------------------------------------------*
Procedure FontColorBrowse()
*--------------------------------------------------------*
   If IsControlDefine(browse_1,oWndBase)
      aBackClr := GetColor()
      oWndBase.Browse_1.Fontcolor := aBackClr
      SaveArchIni(cBaseFolder+'\')
      Actualizar()
   Endif
Return
*--------------------------------------------------------*
Procedure FontNameBrowse()
*--------------------------------------------------------*
   If IsControlDefine(browse_1,oWndBase)
      aFont := GetFont()
      oWndBase.Browse_1.Fontname := aFont[1]
      oWndBase.Browse_1.Fontsize := aFont[2]
      SaveArchIni(cBaseFolder+'\')
      Actualizar()
   Endif
Return
*--------------------------------------------------------*
Procedure ExportData()
*--------------------------------------------------------*
   Local cExt, cSaveFile, cAlias, nRecno ,nIndex := 1

   If !Empty( cbase )

        aFiles :={ {"DBF files (*.dbf)"      , "*.dbf"}, ;
                   {"Text files (*.txt)"     , "*.txt"}, ;
                   {"Data files (*.dat)"     , "*.dat"}, ;
                   {"Excel files (*.xls)"    , "*.xls"}, ;
                   {"DbaseIII files (*.prg)" , "*.prg"}, ;
                   {"All files (*.*)"        , "*.*"  }  }

	cSaveFile := PutFile2( aFiles, , ,  )

	IF !Empty( cSaveFile )

	        If right(cSaveFile,3)=='dbf'
                   nIndex := 1
                   cExt :='dbf'
                Endif
                If right(cSaveFile,3)=='txt'
                   nIndex := 2
                   cExt :='txt'
                Endif
	        If right(cSaveFile,3)=='dat'
                   nIndex := 3
                   cExt :='dat'
                Endif
	        If right(cSaveFile,3)=='xls'
                   nIndex := 4
                   cExt :='xls'
                Endif
	        If right(cSaveFile,3)=='prg'
                   nIndex := 5
                   cExt :='prg'
                Endif

                MsgInfo(cSaveFile,PROGRAM)

		cSaveFile := IF( ( AT( ".", cSaveFile ) > 0 ), cSaveFile, ( cSaveFile + "." + cExt ) )

		IF File( cSaveFile )
			IF !MsgYesNo( cSaveFile + " already exists." + CRLF + ;
				"Overwrite existing file?" )
				Return
			ENDIF
 		ENDIF
		cAlias := cbase
		nRecno := (cAlias)->( Recno() )
		(cAlias)->( DBGoTop() )
		IF nIndex = 2 .OR. nIndex = 3
			(cAlias)->( __dbSDF(.T.,(cSaveFile),{ },,,,,.F. ) )
		ELSEIF nIndex = 4
			SaveToXls( cAlias, cSaveFile )
		ELSEIF nIndex = 5
			SaveToPrg( cAlias, cSaveFile )
		ELSE
			(cAlias)->( __dbCopy((cSaveFile),{ },,,,,.F.,) )
		ENDIF
		(cAlias)->( DBGoto(nRecno) )
	ENDIF

   Endif

Return

*--------------------------------------------------------*
Procedure SaveToXls( cAlias, cFile )
*--------------------------------------------------------*
   Local oExcel,  oSheet, oBook, aColumns, nCell := 1

   If !Empty( cbase )

/*
	oExcel := CreateObject( "Excel.Application" )
	if Ole2TxtError() != 'S_OK'
	    MsgStop('Excel is not available!', PROGRAM )
	    RETURN
	endif
*/

        IF ( oExcel := win_oleGetActiveObject("Excel.Application" )) == NIL
           IF ( oExcel := win_oleCreateObject("Excel.Application" ) ) == NIL
              MsgStop( "ERROR! Excel is not available. ["+ Ole2TxtError()+ "]", PROGRAM )
              Return
           ENDIF
        ENDIF

	oExcel:Visible := .F.
	oExcel:WorkBooks:Add()
	oSheet := oExcel:Get( "ActiveSheet" )

	Aeval( (cAlias)->( DBstruct(cAlias) ), { |e,i| oSheet:Cells( nCell, i ):Value := e[DBS_NAME] } )
	do while !(cAlias)->( EoF() )
		nCell++
		aColumns := (cAlias)->( Scatter() )
		aEval( aColumns, { |e,i| oSheet:Cells( nCell, i ):Value := e } )
		(cAlias)->( DBskip() )
	enddo

	oBook := oExcel:Get("ActiveWorkBook")
	oBook:Title   := cAlias
	oBook:Subject := cAlias
	oBook:SaveAs(cFile)
	oExcel:Quit()

   Endif

Return

#xtranslate fWriteLn( <xHandle>, <cString> ) ;
=> ;
            fWrite( <xHandle>, <cString> + CRLF )
*--------------------------------------------------------*
Procedure SaveToPrg( cAlias, cFile )
*--------------------------------------------------------*
   Local handle := fCreate(cFile, FC_NORMAL), nLen := Len( (cAlias)->( DBstruct(cAlias) ) )

   If !Empty( cbase )

	fWriteLn(handle, "*-------------------------------------------------*")
	fWriteLn(handle, " PROCEDURE MAKE_DataBase()")
	fWriteLn(handle, "*-------------------------------------------------*")

	fWriteLn(handle, ' DBCREATE ("' + SubStr(cAlias, 1, RAT("_", cAlias) - 1) + '", {;')

	Aeval( (cAlias)->( DBstruct(cAlias) ), { |e,i| fWriteLn( handle, ;
		Chr(9) + '{ ' + padr('"' + e[DBS_NAME] + '",', 14) + '"' + Trim(e[DBS_TYPE]) + '",' + Str(e[DBS_LEN], 4) + ',' + Str(e[DBS_DEC], 3) + ;
		if(i < nLen, ' },;', ' }}, "'+( cAlias )->( RDDNAME() ) +'")') ) } )

	fWriteLn(handle, " RETURN")
	fClose(handle)

   Endif

Return
*--------------------------------------------------------*
Function Scatter()
*--------------------------------------------------------*
   Local aRecord[fcount()]
Return aEval( aRecord, {|x,n| aRecord[n] := FieldGet( n ) } )
*--------------------------------------------------------*
Function Gather( paRecord )
*--------------------------------------------------------*
Return aEval( paRecord, {|x,n| FieldPut( n, x ) } )
*--------------------------------------------------------*
Procedure printlist(cBase, aNomb, aLong)
*--------------------------------------------------------*

If !Empty( cbase )

   aName := {}
   For n := 1 to FCount()
       aadd( aName , Fieldname(n) )
   Next

   aHdr1 := array(len(aName))
   aSize := array(len(aName))
   aTot  := array(len(aName))
   afill(aHdr1, '')
   afill(aSize, 10)
   afill(aTot, .F.)

   set deleted on

   ( cBase )->( dbgotop() )

        DO REPORT                           ;
           TITLE   cbase                  ;
           HEADERS  aHdr1, aName            ;
           FIELDS   aName                   ;
           WIDTHS   aSize                   ;
           TOTALS   aTot                    ;
           WORKAREA &cBase                  ;
           LPP 60                           ;
           CPL 120                          ;
           LMARGIN  2                       ;
           PAPERSIZE DMPAPER_LETTER         ;
           PREVIEW

   set deleted off

Endif

Return

*--------------------------------------------------------*
Procedure Salida()
*--------------------------------------------------------*

   if( MsgYesNo("Exit ?",PROGRAM), oWndBase.release, Nil )

Return
*--------------------------------------------------------*
Function MsgAbout()
*--------------------------------------------------------*
Return MsgInfo ( PadC("(c)2009 MigSoft <mig2soft@yahoo.com> ",70) + CRLF+ CRLF+;
                 PadC("Operating System: " + Os(),70)+ CRLF+;
                 PadC("Developed in : " + SubStr(MiniGUIVersion(), 1, 28),70) + CRLF+;
                 PadC("xBase Compiler: " + Version(),70)+ CRLF+;
                 PadC("C Compiler: " + Hb_Compiler(),70) , PROGRAM+" "+VERSION )

*--------------------------------------------------------*
Procedure OnlyDel(nOpt)
*--------------------------------------------------------*
   If !Empty( cbase )
      ( cbase )->( DbGoto(oWndBase.Browse_1.Value) )

      If nOpt = 1
         Set Filter to Deleted()
      Endif
      If nOpt = 2
         Set dele off
         Set Filter to !Deleted()
      Endif
      If nOpt = 3
         Set Filter to
      Endif

      go top

      oWndBase.Browse_1.Refresh
      oWndBase.Browse_1.SetFocus
   Endif

Return
*------------------------------------------------------------*
PROCEDURE Unsorted
*------------------------------------------------------------*

   If !Empty( cbase )
       SET INDEX TO
       SET ORDER TO
       GO TOP

       oWndBase.Browse_1.Refresh
       oWndBase.Browse_1.SetFocus
   Endif

RETURN
*------------------------------------------------------------*
Procedure LoadArchIni(cPath)
*------------------------------------------------------------*
   cFont       := 'MS Sans Serif'
   nSize       := 8
   aFntClr     := {0,0,0}
   aBackClr    := {255,255,255}

   BEGIN INI FILE cpath+'dbview.ini'
         GET cFont     SECTION "Font"      ENTRY "Name"   DEFAULT cFont
         GET nSize     SECTION "Font"      ENTRY "Size"   DEFAULT nSize
         GET aFntClr   SECTION "Font"      ENTRY "Color"  DEFAULT aFntClr
         GET aBackClr  SECTION "Interface" ENTRY "Color"  DEFAULT aBackClr
   END INI

Return
*------------------------------------------------------------*
Procedure SaveArchIni(cPath)
*------------------------------------------------------------*
   BEGIN INI FILE cpath+'dbview.ini'
         SET SECTION "Font"      ENTRY "Name"  TO oWndBase.Browse_1.Fontname
         SET SECTION "Font"      ENTRY "Size"  TO oWndBase.Browse_1.Fontsize
         SET SECTION "Font"      ENTRY "Color" TO oWndBase.Browse_1.fontcolor
         SET SECTION "Interface" ENTRY "Color" TO oWndBase.Browse_1.Backcolor
   END INI

Return
*------------------------------------------------------------*
Procedure VerRegistro()
*------------------------------------------------------------*
   If IsControlDefine(browse_1,oWndBase)
       Administradbf( cBase, oWndBase.Browse_1.Value )
       Actualizar()
   Endif
Return

*--------------------------------------------------------*
Procedure DBQuery()
*--------------------------------------------------------*
   Local cField, cComp, cType := ""
   Local cChar := "", nNum := 0, dDate := ctod(""), nLog := 1
   Local cExpr := ""
   Local aQuery_ := {"", "", ""}
   Local aUndo_ := {}
   Local aFlds_ := {}
   Local aComp_ := { "== Equal", ;
                     "<> Not equal", ;
                     "<  Less than", ;
                     ">  Greater than", ;
                     "<= Less or equal", ;
                     ">= Greater or equal", ;
                     "() Contains", ;
                     "$  Is contained in", ;
                     '"" Is empty (Blank)' }

   Private cAlias, cDBFile


   If !Empty( cbase )
	cDBFile := cFileNoPath(dbf())
	cAlias := cbase
	IF !Empty((cAlias)->( DbFilter() ))
		(cAlias)->( DbClearFilter() )
	ENDIF
	aEval((cAlias)->( DBStruct() ), {|e| aAdd(aFlds_, e[DBS_NAME]) } )
	aAdd(aFlds_, "Deleted()") // Add this as if it were a logical field!

	cField := aFlds_[1]
	cComp := aComp_[1]

	DEFINE WINDOW Form_Query ;
		AT 0, 0 WIDTH 570 HEIGHT 305 ;
		TITLE PROGRAM+VERSION+"- Query" ;
		ICON 'MAIN' ;
		MODAL ;
		ON INIT ( Form_Query.List_1.Setfocus, cType := GetType(cField, aFlds_, @cChar), ;
			Form_Query.Text_1.Enabled := ( cType == "C" ), ;
			Form_Query.Text_2.Enabled := ( cType == "N" ), ;
			Form_Query.Date_1.Enabled := ( cType == "D" ), ;
			Form_Query.Combo_1.Enabled := ( cType == "L" ) ) ;
		FONT "MS Sans Serif" ;
		SIZE 8

	    DEFINE FRAME Frame_1
            ROW    10
            COL    260
            WIDTH  290
            HEIGHT 135
            CAPTION "Value"
            OPAQUE .T.
	    END FRAME

	    DEFINE LABEL Label_1
            ROW    30
            COL    270
            WIDTH  60
            HEIGHT 20
            VALUE "Character"+":"
            VISIBLE .T.
	    END LABEL

	    DEFINE LABEL Label_2
            ROW    60
            COL    270
            WIDTH  60
            HEIGHT 20
            VALUE "Numeric"+":"
            VISIBLE .T.
	    END LABEL

	    DEFINE LABEL Label_3
            ROW    90
            COL    270
            WIDTH  60
            HEIGHT 20
            VALUE "Date"+":"
            VISIBLE .T.
	    END LABEL

	    DEFINE LABEL Label_4
            ROW    120
            COL    270
            WIDTH  60
            HEIGHT 20
            VALUE "Logical"+":"
            VISIBLE .T.
	    END LABEL

	    DEFINE LABEL Label_5
            ROW    6
            COL    12
            WIDTH  80
            HEIGHT 16
            VALUE "Field"
            VISIBLE .T.
	    END LABEL

	    DEFINE LABEL Label_6
            ROW    6
            COL    134
            WIDTH  120
            HEIGHT 16
            VALUE "Comparison"
            VISIBLE .T.
	    END LABEL

	    DEFINE LISTBOX List_1
            ROW    20
            COL    10
            WIDTH  114
            HEIGHT 130
            ITEMS aFlds_
            VALUE 1
            ONCHANGE ( cField := aFlds_[This.Value], cType := GetType(cField, aFlds_, @cChar), ;
			Form_Query.Text_1.Enabled := ( cType == "C" ), ;
			Form_Query.Text_2.Enabled := ( cType == "N" ), ;
			Form_Query.Date_1.Enabled := ( cType == "D" ), ;
			Form_Query.Combo_1.Enabled := ( cType == "L" ) )
            ONDBLCLICK Form_Query.Button_1.OnClick
            TABSTOP .T.
            VISIBLE .T.
            SORT .F.
            MULTISELECT .F.
	    END LISTBOX

	    DEFINE LISTBOX List_2
            ROW    20
            COL    132
            WIDTH  118
            HEIGHT 130
            ITEMS aComp_
            VALUE 1
            ONCHANGE cComp := aComp_[This.Value]
            ONLOSTFOCUS IF( CheckComp(cType, cComp), , Form_Query.List_2.Setfocus )
            ONDBLCLICK Form_Query.Button_1.OnClick
            TABSTOP .T.
            VISIBLE .T.
            SORT .F.
            MULTISELECT .F.
	    END LISTBOX

	    DEFINE EDITBOX Edit_1
            ROW    170
            COL    10
            WIDTH  240
            HEIGHT 100
            VALUE ""
            ONCHANGE ( cExpr := This.Value, ;
		Form_Query.Button_2.Enabled := ( !empty(cExpr) ), ;
		Form_Query.Button_8.Enabled := ( !empty(cExpr) ), ;
		Form_Query.Button_10.Enabled := ( !empty(cExpr) ) )
            ONGOTFOCUS Nil
            ONLOSTFOCUS Nil
            FONTBOLD .T.
            TABSTOP .T.
            VISIBLE .T.
	    END EDITBOX

	    DEFINE LABEL Label_7
            ROW    154
            COL    12
            WIDTH  100
            HEIGHT 16
            VALUE "Query expression"+":"
            VISIBLE .T.
	    END LABEL

	    DEFINE TEXTBOX Text_1
            ROW    26
            COL    340
            WIDTH  200
            HEIGHT 24
            ONCHANGE cChar := This.Value
            ONGOTFOCUS Form_Query.Text_1.Enabled := ( cType == "C" )
            ONENTER ( Form_Query.Button_1.OnClick, Form_Query.Button_8.Setfocus )
            FONTBOLD .T.
            TABSTOP .T.
            VISIBLE .T.
            VALUE cChar
	    END TEXTBOX

	    DEFINE TEXTBOX Text_2
		ROW    56
		COL    340
	        WIDTH  200
		HEIGHT 24
	        NUMERIC .T.
		INPUTMASK "9999999.99"
	        RIGHTALIGN .T.
		MAXLENGTH 10
	        ONCHANGE nNum := This.Value
		ONGOTFOCUS Form_Query.Text_2.Enabled := ( cType == "N" )
	        ONENTER ( Form_Query.Button_1.OnClick, Form_Query.Button_8.Setfocus )
		FONTBOLD .T.
	        TABSTOP .T.
		VISIBLE .T.
	        VALUE nNum
	    END TEXTBOX

            DEFINE DATEPICKER Date_1
	        ROW    86
		COL    340
	        WIDTH  110
		HEIGHT 24
	        VALUE dDate
		SHOWNONE .T.
	        UPDOWN .T.
		ONCHANGE dDate := This.Value
	        ONGOTFOCUS Form_Query.Date_1.Enabled := ( cType == "D" )
		FONTBOLD .T.
	        TABSTOP .T.
		VISIBLE .T.
            END DATEPICKER

	    DEFINE COMBOBOX Combo_1
	        ROW    116
		COL    340
	        WIDTH  110
		HEIGHT 60
	        ITEMS {"True (.T.)", "False (.F.)"}
		VALUE nLog
	        ONCHANGE nLog := This.Value
		ONGOTFOCUS Form_Query.Combo_1.Enabled := ( cType == "L" )
	        ONENTER ( Form_Query.Button_1.OnClick, Form_Query.Button_8.Setfocus )
		FONTBOLD .T.
	        TABSTOP .T.
		VISIBLE .T.
	    END COMBOBOX

	    DEFINE BUTTON Button_1
	        ROW    156
		COL    260
	        WIDTH  136
		HEIGHT 24
	        CAPTION "Add"
		ACTION IF( CheckComp(cType, cComp), ( AddExpr(@cExpr, aUndo_, cField, cComp, ;
			iif(cType == "C", cChar, iif(cType == "N", nNum, ;
			iif(cType == "D", dDate, (nLog == 1))))), ;
			Form_Query.Button_2.Enabled := ( Len(aUndo_) > 0 ), ;
			Form_Query.Button_8.Enabled := ( !empty(cExpr) ), ;
			Form_Query.Button_10.Enabled := ( !empty(cExpr) ) ), Form_Query.List_2.Setfocus )
	        ONLOSTFOCUS Form_Query.Button_2.Enabled := ( Len(aUndo_) > 0 )
		TABSTOP .T.
	        VISIBLE .T.
	    END BUTTON

	    DEFINE BUTTON Button_2
	        ROW    156
		COL    414
	        WIDTH  136
		HEIGHT 24
	        CAPTION "Undo"
		ACTION ( Undo(@cExpr, aUndo_), ;
			Form_Query.Button_2.Enabled := ( Len(aUndo_) > 0 ), ;
			Form_Query.Button_8.Enabled := ( !empty(cExpr) ), ;
			Form_Query.Button_10.Enabled := ( !empty(cExpr) ) )
	        ONLOSTFOCUS Form_Query.Button_2.Enabled := ( Len(aUndo_) > 0 )
		TABSTOP .T.
	        VISIBLE .T.
	    END BUTTON

	    DEFINE BUTTON Button_3
		ROW    196
	        COL    260
		WIDTH  44
	        HEIGHT 24
		CAPTION ".and."
	        ACTION AddText(@cExpr, aUndo_, ".and. ")
		TABSTOP .T.
	        VISIBLE .T.
	    END BUTTON

	    DEFINE BUTTON Button_4
	        ROW    196
		COL    321
	        WIDTH  44
		HEIGHT 24
	        CAPTION ".or."
		ACTION AddText(@cExpr, aUndo_, ".or. ")
	        TABSTOP .T.
		VISIBLE .T.
	    END BUTTON

	    DEFINE BUTTON Button_5
	        ROW    196
		COL    383
	        WIDTH  44
		HEIGHT 24
	        CAPTION ".not."
		ACTION AddText(@cExpr, aUndo_, ".not. ")
	        TABSTOP .T.
		VISIBLE .T.
	    END BUTTON

	    DEFINE BUTTON Button_6
	        ROW    196
		COL    444
	        WIDTH  44
		HEIGHT 24
	        CAPTION "("
		ACTION AddText(@cExpr, aUndo_, "( ")
	        TABSTOP .T.
		VISIBLE .T.
	    END BUTTON

	    DEFINE BUTTON Button_7
	        ROW    196
		COL    505
	        WIDTH  44
		HEIGHT 24
	        CAPTION ")"
		ACTION AddText(@cExpr, aUndo_, " ) ")
	        TABSTOP .T.
		VISIBLE .T.
	    END BUTTON

	    DEFINE BUTTON Button_8
	        ROW    236
		COL    260
	        WIDTH  62
		HEIGHT 24
	        CAPTION "Apply"
		ACTION IF( RunQuery(cExpr), Form_Query.Button_9.OnClick, )
	        ONLOSTFOCUS Form_Query.Button_8.Enabled := ( !empty(cExpr) )
		TABSTOP .T.
	        VISIBLE .T.
	    END BUTTON

	    DEFINE BUTTON Button_9
	        ROW    236
		COL    336
	        WIDTH  62
		HEIGHT 24
	        CAPTION "Close"
		ACTION ( SetProperty( "oWndBase", "Browse_1", "Value", (cAlias)->( RecNo() ) ), ;
			DoMethod( "oWndBase", "Browse_1", 'Refresh' ), ;
			Form_Query.Release, DoMethod( "oWndBase", 'Setfocus' ) )
	        TABSTOP .T.
		VISIBLE .T.
	    END BUTTON

	    DEFINE BUTTON Button_10
	        ROW    236
		COL    412
	        WIDTH  62
		HEIGHT 24
	        CAPTION "Save"
		ACTION SaveQuery(cExpr, aQuery_,cBase)
	        ONLOSTFOCUS Form_Query.Button_10.Enabled := ( !empty(cExpr) )
		TABSTOP .T.
	        VISIBLE .T.
	    END BUTTON

	    DEFINE BUTTON Button_11
	        ROW    236
		COL    488
	        WIDTH  62
		HEIGHT 24
	        CAPTION "Load"
		ACTION iif( LoadQuery(@cExpr, aQuery_,cBase), ( aUndo_ := {}, ;
			Form_Query.Button_8.Enabled := ( !empty(cExpr) ), ;
			Form_Query.Button_10.Enabled := ( !empty(cExpr) ) ), )
	        TABSTOP .T.
		VISIBLE .T.
	    END BUTTON

            ON KEY ESCAPE ACTION IF( CheckComp(cType, cComp), Form_Query.Button_9.OnClick, Form_Query.List_2.Setfocus )

	END WINDOW

	Form_Query.Text_1.Enabled := .F.
	Form_Query.Text_2.Enabled := .F.
	Form_Query.Date_1.Enabled := .F.
	Form_Query.Combo_1.Enabled := .F.
	Form_Query.Button_2.Enabled := .F.
	Form_Query.Button_8.Enabled := .F.
	Form_Query.Button_10.Enabled := .F.

	CENTER WINDOW Form_Query

	ACTIVATE WINDOW Form_Query
   ENDIF

RETURN
*--------------------------------------------------------*
Procedure LimpiaFiltro()
*--------------------------------------------------------*
   If !Empty( cbase )
      (cbase)->( DbClearFilter() )
      Actualizar()
      go top
    Endif
Return

*------------------------------------------------------------------------------*
Static Procedure Search_Replace( lReplace )
*------------------------------------------------------------------------------*
   Local aColumns := { FCount() }

   DEFAULT lReplace := .f.

   IF !Empty(cbase)
	Private lFirstFind := .T., lFind := .T., cFind := "", cFindStr, cField, cAlias := (cbase), cReplStr, nCurRec

	Aeval( (cAlias)->( DBstruct(cAlias) ), {|e| Aadd(aColumns, e[1])})

	DEFINE WINDOW Form_Find ;
		AT 0, 0 WIDTH 449 HEIGHT 222 ;
		TITLE IF(lReplace, PROGRAM+VERSION+"- Replace", PROGRAM+VERSION+"- Search") ;
		ICON 'MAIN' ;
		MODAL ;
		ON INIT ( Form_Find.Combo_1.DisplayValue := "", Form_Find.Combo_2.DisplayValue := "", Form_Find.Combo_1.Setfocus ) ;
		FONT "MS Sans Serif" ;
		SIZE 8

		DEFINE LABEL Label_1
	        ROW    10
		COL    12
	        WIDTH  60
		HEIGHT 21
	        VALUE "Table:"
		VISIBLE .T.
	        AUTOSIZE .F.
		END LABEL

		DEFINE LABEL Label_11
	        ROW    10
		COL    95
	        WIDTH  240
		HEIGHT 21
	        VALUE cbase
		VISIBLE .T.
	        AUTOSIZE .F.
		END LABEL

		DEFINE LABEL Label_2
	        ROW    36
		COL    12
	        WIDTH  60
		HEIGHT 21
	        VALUE "Look for:"
		VISIBLE .T.
	        AUTOSIZE .F.
		END LABEL

		DEFINE COMBOBOX Combo_1
			ROW	32
			COL	95
			ITEMS aSearch
			VALUE nSearch
			WIDTH 240
			DISPLAYEDIT .T.
			ON DISPLAYCHANGE ( lFirstFind := .T., Form_Find.Button_1.Enabled := !Empty(Form_Find.Combo_1.DisplayValue) )
			ON CHANGE ( lFirstFind := .T., Form_Find.Button_1.Enabled := .t. )
			VISIBLE .T.
		END COMBOBOX

		DEFINE LABEL Label_3
	        ROW    62
		COL    12
	        WIDTH  80
		HEIGHT 18
	        VALUE "Replace with:"
		VISIBLE lReplace
	        AUTOSIZE .F.
		END LABEL

		DEFINE COMBOBOX Combo_2
			ROW	60
			COL	95
			ITEMS aReplace
			VALUE nReplace
			WIDTH 240
			DISPLAYEDIT .T.
			ON DISPLAYCHANGE ( Form_Find.Button_3.Enabled := !Empty(Form_Find.Combo_1.DisplayValue) .AND. !Empty(Form_Find.Combo_2.DisplayValue), ;
				Form_Find.Button_4.Enabled := !Empty(Form_Find.Combo_1.DisplayValue) .AND. !Empty(Form_Find.Combo_2.DisplayValue) )
			ON CHANGE ( Form_Find.Button_3.Enabled := .t., Form_Find.Button_4.Enabled := .t. )
			VISIBLE lReplace
		END COMBOBOX

		DEFINE FRAME Frame_1
	        ROW    92
		COL    12
	        WIDTH  98
		HEIGHT 92
		CAPTION "Direction"
	        OPAQUE .T.
		END FRAME

		DEFINE RADIOGROUP Radio_1
			ROW	104
			COL	22
			OPTIONS { "Forward" , "Backward" , "Entire scope" }
			VALUE nDirect
			WIDTH 82
			ONCHANGE ( nDirect := This.Value, lFirstFind := .T. )
			TABSTOP .T.
		END RADIOGROUP

		DEFINE LABEL Label_4
	        ROW    100
		COL    120
	        WIDTH  100
		HEIGHT 18
	        VALUE "Search in column:"
		VISIBLE .T.
	        AUTOSIZE .F.
		END LABEL

		DEFINE COMBOBOX Combo_3
			ROW	96
			COL	215
			ITEMS aColumns
			VALUE nColumns
			WIDTH 120
			ON CHANGE lFirstFind := .T.
		END COMBOBOX

		DEFINE CHECKBOX Check_1
			ROW	130
			COL	120
			WIDTH  260
			CAPTION "Match &case"
			VALUE lMatchCase
			ON CHANGE lFirstFind := .T.
		END CHECKBOX

		DEFINE CHECKBOX Check_2
			ROW	154
			COL	120
			WIDTH  260
			CAPTION "Match &whole word only"
			VALUE lMatchWhole
			ON CHANGE lFirstFind := .T.
		END CHECKBOX

		DEFINE BUTTON Button_1
	        ROW    10
		COL    350
	        WIDTH  80
		HEIGHT 24
	        CAPTION "&Find Next"
		ACTION FindNext(Form_Find.Combo_1.DisplayValue, Form_Find.Combo_3.Value+1, ; //MigSoft
			Form_Find.Check_1.Value, Form_Find.Check_2.Value)
	        TABSTOP .T.
		VISIBLE .T.
		END BUTTON

		DEFINE BUTTON Button_2
	        ROW    40
	        COL    350
		WIDTH  80
	        HEIGHT 24
		CAPTION "&Close"
	        ACTION ( ThisWindow.Release,(cAlias)->( RecNo() ) )
		TABSTOP .T.
	        VISIBLE .T.
		END BUTTON

		DEFINE BUTTON Button_3
	        ROW    70
		COL    350
	        WIDTH  80
		HEIGHT 24
	        CAPTION IF(lReplace, "&"+"Replace", "&Replace...")
		ACTION IF(lReplace, DoReplace(Form_Find.Combo_1.DisplayValue, Form_Find.Combo_2.DisplayValue, ;
			Form_Find.Combo_3.Value+1, Form_Find.Check_1.Value, Form_Find.Check_2.Value), ;
			( Form_Find.Button_3.Caption := "&"+"Replace", Form_Find.Button_3.Enabled := .f., ;
			Form_Find.Button_4.Visible := .t., Form_Find.Button_4.Enabled := .f., Form_Find.Label_3.Visible := .t., ;
			Form_Find.Combo_2.Visible := .t., ThisWindow.Title := PROGRAM+VERSION+"- Replace", Form_Find.Combo_1.Setfocus, lReplace := .t. ))  
	        TABSTOP .T.
		VISIBLE .T.
		END BUTTON

		DEFINE BUTTON Button_4
	        ROW    100
		COL    350
	        WIDTH  80
		HEIGHT 24
	        CAPTION "Replace &All"
		ACTION DoReplace(Form_Find.Combo_1.DisplayValue, Form_Find.Combo_2.DisplayValue, ;
			Form_Find.Combo_3.Value+1, Form_Find.Check_1.Value, Form_Find.Check_2.Value, .t.)
	        TABSTOP .T.
		VISIBLE lReplace
		END BUTTON

		ON KEY RETURN ACTION IF(lReplace, Form_Find.Button_3.OnClick, Form_Find.Button_1.OnClick )
		ON KEY ESCAPE ACTION Form_Find.Button_2.OnClick

	END WINDOW

	Form_Find.Button_1.Enabled := .f.
	Form_Find.Button_3.Enabled := !lReplace
	Form_Find.Button_4.Enabled := !lReplace

	CENTER WINDOW Form_Find

	ACTIVATE WINDOW Form_Find

   ENDIF

Return

*------------------------------------------------------------------------------*
Static Procedure FindNext( cString, nField, lCase, lWhole )
*------------------------------------------------------------------------------*
   Local aColumns := (cAlias)->( DBstruct(cAlias) )
   Local nRecno := (cAlias)->( RecNo() ), cType

	IF EMPTY(cString)
		Return
	ELSEIF ASCAN(aSearch, cString) == 0
		AADD(aSearch, cString)
		Form_Find.Combo_1.AddItem(cString)
	ENDIF
	IF !EMPTY(nField)
		nColumns := nField
	ENDIF
	lMatchCase := lCase
	lMatchWhole := lWhole

	lFind := .T.
	IF nField == 1
		cFind := ""
		IF lFirstFind
			lFirstFind := .F.
			IF nDirect == 3
				(cAlias)->( DbGotop() )
				DO WHILE !(cAlias)->( EoF() )
					cFindStr := IF(lCase, ALLTRIM(cString), UPPER(ALLTRIM(cString)))
					aColumns := (cAlias)->( Scatter() )
					Aeval(aColumns, {|x| cFind += XtoC(x) + " "})
					IF lCase
						IF cFindStr $ cFind
							EXIT
						ENDIF
					ELSE
						IF cFindStr $ UPPER(cFind)
							EXIT
						ENDIF
					ENDIF
					(cAlias)->( DbSkip() )
				ENDDO
				IF (cAlias)->( EoF() )
					lFind := .F.
					(cAlias)->( DbGoto(nRecno) )
					MsgInfo( "Can not find the string"+' "'+cString+'"' )
				ENDIF
			ELSEIF nDirect == 2
				(cAlias)->( DbSkip(-1) )
				DO WHILE !(cAlias)->( BoF() )
					cFindStr := IF(lCase, ALLTRIM(cString), UPPER(ALLTRIM(cString)))
					aColumns := (cAlias)->( Scatter() )
					Aeval(aColumns, {|x| cFind += XtoC(x) + " "})
					IF lCase
						IF cFindStr $ cFind
							EXIT
						ENDIF
					ELSE
						IF cFindStr $ UPPER(cFind)
							EXIT
						ENDIF
					ENDIF
					(cAlias)->( DbSkip(-1) )
				ENDDO
				IF (cAlias)->( BoF() )
					lFind := .F.
					(cAlias)->( DbGoto(nRecno) )
					MsgInfo( "Can not find the string"+' "'+cString+'"' )
				ENDIF
			ELSEIF nDirect == 1
				(cAlias)->( DbSkip() )
				DO WHILE !(cAlias)->( EoF() )
					cFindStr := IF(lCase, ALLTRIM(cString), UPPER(ALLTRIM(cString)))
					aColumns := (cAlias)->( Scatter() )
					Aeval(aColumns, {|x| cFind += XtoC(x) + " "})
					IF lCase
						IF cFindStr $ cFind
							EXIT
						ENDIF
					ELSE
						IF cFindStr $ UPPER(cFind)
							EXIT
						ENDIF
					ENDIF
					(cAlias)->( DbSkip() )
				ENDDO
				IF (cAlias)->( EoF() )
					lFind := .F.
					(cAlias)->( DbGoto(nRecno) )
					MsgInfo( "Can not find the string"+' "'+cString+'"' )
				ENDIF
			ENDIF
		ELSEIF lFind
			IF nDirect == 2
				(cAlias)->( DbSkip(-1) )
			ELSE
				(cAlias)->( DbSkip() )
			ENDIF
			DO WHILE !IF(nDirect = 2, (cAlias)->( BoF() ), (cAlias)->( EoF() ))
				cFindStr := IF(lCase, ALLTRIM(cString), UPPER(ALLTRIM(cString)))
				aColumns := (cAlias)->( Scatter() )
				Aeval(aColumns, {|x| cFind += XtoC(x) + " "})
				IF lCase
					IF cFindStr $ cFind
						EXIT
					ENDIF
				ELSE
					IF cFindStr $ UPPER(cFind)
						EXIT
					ENDIF
				ENDIF
				IF nDirect == 2
					(cAlias)->( DbSkip(-1) )
				ELSE
					(cAlias)->( DbSkip() )
				ENDIF
			ENDDO
			IF (cAlias)->( EoF() ) .OR. (cAlias)->( BoF() )
				lFind := .F.
				(cAlias)->( DbGoto(nRecno) )
				MsgInfo( "There are still no such records!" )
			ENDIF
		ENDIF
	ELSE
		cField := aColumns[nField-1][1]
		cType := aColumns[nField-1][2]
		IF cType $ "CND"
			IF cType == "C"
				IF lWhole
					cFindStr := cString
					cFind := "ALLTRIM((cAlias)->((&cField)))==M->cFindStr"
				ELSE
					cFindStr := IF(lCase, ALLTRIM(cString), UPPER(ALLTRIM(cString)))
					IF lCase
						cFind := "M->cFindStr $ (cAlias)->((&cField))"
					ELSE
						cFind := "M->cFindStr $ UPPER((cAlias)->((&cField)))"
					ENDIF
				ENDIF
			ELSEIF cType == "N"
				cFindStr := VAL(cString)
				cFind := "(cAlias)->((&cField))=M->cFindStr"
				cFind := "(cAlias)->((&cField))=M->cFindStr"
			ELSEIF cType == "D"
				cFindStr := CTOD(cString)
				cFind := "(cAlias)->((&cField))=M->cFindStr"
			ENDIF
			IF lFirstFind
				lFirstFind := .F.
				IF nDirect == 3
					(cAlias)->( __dbLocate({||(&cFind)},,,,.F.) )
					IF (cAlias)->( EoF() )
						lFind := .F.
						(cAlias)->( DbGoto(nRecno) )
						MsgInfo( "Can not find the string"+' "'+cString+'"' )
					ENDIF
				ELSEIF nDirect == 2
					(cAlias)->( DbSkip(-1) )
					DO WHILE !(cAlias)->( BoF() )
						IF &cFind
							EXIT
						ENDIF
						(cAlias)->( DbSkip(-1) )
					ENDDO
					IF (cAlias)->( BoF() )
						lFind := .F.
						(cAlias)->( DbGoto(nRecno) )
						MsgInfo( "Can not find the string"+' "'+cString+'"' )
					ENDIF
				ELSEIF nDirect == 1
					(cAlias)->( DbSkip() )
					(cAlias)->( __dbLocate({||(&cFind)},,,,.T.) )
					IF (cAlias)->( EoF() )
						lFind := .F.
						(cAlias)->( DbGoto(nRecno) )
						MsgInfo( "Can not find the string"+' "'+cString+'"' )
					ENDIF
				ENDIF
			ELSEIF lFind
				IF nDirect == 2
					(cAlias)->( DbSkip(-1) )
					DO WHILE !(cAlias)->( BoF() )
						IF &cFind
							EXIT
						ENDIF
						(cAlias)->( DbSkip(-1) )
					ENDDO
				ELSE
					(cAlias)->( __dbContinue() )
				ENDIF
				IF (cAlias)->( EoF() ) .OR. (cAlias)->( BoF() )
					lFind := .F.
					(cAlias)->( DbGoto(nRecno) )
					MsgInfo( "There are still no such records!" )
				ENDIF
			ENDIF
		ENDIF
	ENDIF
	SetProperty( "oWndBase", "Browse_1", "Value", (cAlias)->( RecNo() ) )
	DoMethod( "oWndBase", "Browse_1", 'Refresh' )

Return

*------------------------------------------------------------------------------*
Static Procedure DoReplace(cString, cReplace, nField, lCase, lWhole, lAll)
*------------------------------------------------------------------------------*
   Local aColumns := (cAlias)->( DBstruct(cAlias) ), cType, cFld, i, lReplace
   Local nRecno := (cAlias)->( RecNo() )

   DEFAULT lAll := .f.

	IF EMPTY(cString) .OR. EMPTY(cReplace)
		Return
	ELSEIF ASCAN(aReplace, cReplace) == 0
		AADD(aReplace, cReplace)
		Form_Find.Combo_2.AddItem(cString)
	ENDIF
	IF lAll
		IF ASCAN(aSearch, cString) == 0
			AADD(aSearch, cString)
			Form_Find.Combo_1.AddItem(cString)
		ENDIF
		IF nField == 1
			IF nDirect == 3
				(cAlias)->( DbGotop() )
				DO WHILE !(cAlias)->( EoF() )
					aColumns := (cAlias)->( Scatter() )
					For i := 1 To Len(aColumns)
						cFld := aColumns[i]
						IF cType == "N"
							lReplace := ( cFld = VAL(cString) )
							IF lReplace
								(cAlias)->&cField := VAL(cReplace)
							ENDIF
						ELSEIF cType == "D"
							lReplace := ( cFld = CTOD(cString) )
							IF lReplace
								(cAlias)->&cField := CTOD(cReplace)
							ENDIF
						ELSEIF Valtype( cFld ) == "C"
							IF lWhole
								lReplace := ( cFld == cString )
							ELSE
								IF lCase
									lReplace := cString $ cFld
								ELSE
									lReplace := UPPER(cString) $ UPPER(cFld)
								ENDIF
							ENDIF
							IF lReplace
								IF (cAlias)->( Rlock() )
									cField := (cAlias)->( Field(i) )
									(cAlias)->&cField := STRTRAN(cFld, cString, cReplace)
								ENDIF
								(cAlias)->( DBunlock() )
							ENDIF
						ENDIF
					Next
					(cAlias)->( DbSkip() )
				ENDDO
				(cAlias)->( DbGoto(nRecno) )
			ELSEIF nDirect == 2
				(cAlias)->( DbSkip(-1) )
				DO WHILE !(cAlias)->( BoF() )
					aColumns := (cAlias)->( Scatter() )
					For i := 1 To Len(aColumns)
						cFld := aColumns[i]
						IF cType == "N"
							lReplace := ( cFld = VAL(cString) )
							IF lReplace
								(cAlias)->&cField := VAL(cReplace)
							ENDIF
						ELSEIF cType == "D"
							lReplace := ( cFld = CTOD(cString) )
							IF lReplace
								(cAlias)->&cField := CTOD(cReplace)
							ENDIF
						ELSEIF Valtype( cFld ) == "C"
							IF lWhole
								lReplace := ( cFld == cString )
							ELSE
								IF lCase
									lReplace := cString $ cFld
								ELSE
									lReplace := UPPER(cString) $ UPPER(cFld)
								ENDIF
							ENDIF
							IF lReplace
								IF (cAlias)->( Rlock() )
									cField := (cAlias)->( Field(i) )
									(cAlias)->&cField := STRTRAN(cFld, cString, cReplace)
								ENDIF
								(cAlias)->( DBunlock() )
							ENDIF
						ENDIF
					Next
					(cAlias)->( DbSkip(-1) )
				ENDDO
				(cAlias)->( DbGoto(nRecno) )
			ELSEIF nDirect == 1
				(cAlias)->( DbSkip() )
				DO WHILE !(cAlias)->( EoF() )
					aColumns := (cAlias)->( Scatter() )
					For i := 1 To Len(aColumns)
						cFld := aColumns[i]
						IF cType == "N"
							lReplace := ( cFld = VAL(cString) )
							IF lReplace
								(cAlias)->&cField := VAL(cReplace)
							ENDIF
						ELSEIF cType == "D"
							lReplace := ( cFld = CTOD(cString) )
							IF lReplace
								(cAlias)->&cField := CTOD(cReplace)
							ENDIF
						ELSEIF Valtype( cFld ) == "C"
							IF lWhole
								lReplace := ( cFld == cString )
							ELSE
								IF lCase
									lReplace := cString $ cFld
								ELSE
									lReplace := UPPER(cString) $ UPPER(cFld)
								ENDIF
							ENDIF
							IF lReplace
								IF (cAlias)->( Rlock() )
									cField := (cAlias)->( Field(i) )
									(cAlias)->&cField := STRTRAN(cFld, cString, cReplace)
								ENDIF
								(cAlias)->( DBunlock() )
							ENDIF
						ENDIF
					Next
					(cAlias)->( DbSkip() )
				ENDDO
				(cAlias)->( DbGoto(nRecno) )
			ENDIF
		ELSE
			cField := aColumns[nField-1][1]
			cType := aColumns[nField-1][2]
			IF nDirect == 3
				(cAlias)->( DbGotop() )
				IF (cAlias)->( Flock() )
					cReplStr := cReplace
					cFindStr := ALLTRIM(cString)
					IF cType == "N"
						(cAlias)->( DBEval({||(cAlias)->&(cField) := VAL(cReplStr)},{||(cAlias)->&(cField)=VAL(cFindStr)},,,,.F.) )
					ELSEIF cType == "D"
						(cAlias)->( DBEval({||(cAlias)->&(cField) := CTOD(cReplStr)},{||(cAlias)->&(cField)=CTOD(cFindStr)},,,,.F.) )
					ELSE
						IF lWhole
							(cAlias)->( DBEval({||(cAlias)->&(cField) := STRTRAN((cAlias)->&(cField), cFindStr, cReplStr)},{||(cAlias)->&(cField) == M->cFindStr},,,,.F.) )
						ELSE
							IF lCase
								(cAlias)->( DBEval({||(cAlias)->&(cField) := STRTRAN((cAlias)->&(cField), cFindStr, cReplStr)},{||M->cFindStr $ (cAlias)->&(cField)},,,,.F.) )
							ELSE
								(cAlias)->( DBEval({||(cAlias)->&(cField) := STRTRAN((cAlias)->&(cField), cFindStr, cReplStr)},{||UPPER(M->cFindStr) $ UPPER((cAlias)->&(cField))},,,,.F.) )
							ENDIF
						ENDIF
					ENDIF
				ENDIF
			ELSEIF nDirect == 2
				(cAlias)->( DbGotop() )
				IF (cAlias)->( Flock() )
					nCurRec := nRecno
					cReplStr := cReplace
					cFindStr := ALLTRIM(cString)
					IF cType == "N"
						(cAlias)->( DBEval({||(cAlias)->&(cField) := VAL(cReplStr)},{||(cAlias)->&(cField)=VAL(cFindStr)},{||(cAlias)->( Recno() )<nCurRec},,,.F.) )
					ELSEIF cType == "D"
						(cAlias)->( DBEval({||(cAlias)->&(cField) := CTOD(cReplStr)},{||(cAlias)->&(cField)=CTOD(cFindStr)},{||(cAlias)->( Recno() )<nCurRec},,,.F.) )
					ELSE
						IF lWhole
							(cAlias)->( DBEval({||(cAlias)->&(cField) := STRTRAN((cAlias)->&(cField), cFindStr, cReplStr)},{||(cAlias)->&(cField) == M->cFindStr},{||(cAlias)->( Recno() )<nCurRec},,,.F.) )
						ELSE
							IF lCase
								(cAlias)->( DBEval({||(cAlias)->&(cField) := STRTRAN((cAlias)->&(cField), cFindStr, cReplStr)},{||M->cFindStr $ (cAlias)->&(cField)},{||(cAlias)->( Recno() )<nCurRec},,,.F.) )
							ELSE
								(cAlias)->( DBEval({||(cAlias)->&(cField) := STRTRAN((cAlias)->&(cField), cFindStr, cReplStr)},{||UPPER(M->cFindStr) $ UPPER((cAlias)->&(cField))},{||(cAlias)->( Recno() )<nCurRec},,,.F.) )
							ENDIF
						ENDIF
					ENDIF
				ENDIF
			ELSEIF nDirect == 1
				IF (cAlias)->( Flock() )
					cReplStr := cReplace
					cFindStr := ALLTRIM(cString)
					IF cType == "N"
						(cAlias)->( DBEval({||(cAlias)->&(cField) := VAL(cReplStr)},{||(cAlias)->&(cField)=VAL(cFindStr)},,,,.T.) )
					ELSEIF cType == "D"
						(cAlias)->( DBEval({||(cAlias)->&(cField) := CTOD(cReplStr)},{||(cAlias)->&(cField)=CTOD(cFindStr)},,,,.T.) )
					ELSE
						IF lWhole
							(cAlias)->( DBEval({||(cAlias)->&(cField) := STRTRAN((cAlias)->&(cField), cFindStr, cReplStr)},{||(cAlias)->&(cField) == M->cFindStr},,,,.T.) )
						ELSE
							IF lCase
								(cAlias)->( DBEval({||(cAlias)->&(cField) := STRTRAN((cAlias)->&(cField), cFindStr, cReplStr)},{||M->cFindStr $ (cAlias)->(&(cField))},,,,.T.) )
							ELSE
								(cAlias)->( DBEval({||(cAlias)->&(cField) := STRTRAN((cAlias)->&(cField), cFindStr, cReplStr)},{||UPPER(M->cFindStr) $ UPPER((cAlias)->&(cField))},,,,.T.) )
							ENDIF
						ENDIF
					ENDIF
				ENDIF
			ENDIF
			(cAlias)->( DBunlock() )
			(cAlias)->( DbGoto(nRecno) )
		ENDIF
	ELSE
		lFind := .T.
		FindNext( cString, nField, lCase, lWhole )
		IF nField == 1
			IF lFind
				aColumns := (cAlias)->( Scatter() )
				For i := 1 To Len(aColumns)
					cFld := aColumns[i]
					IF Valtype( cFld ) == "C"
						IF lCase
							lReplace := cString $ cFld
						ELSE
							lReplace := UPPER(cString) $ UPPER(cFld)
						ENDIF
						IF lReplace
							IF (cAlias)->( Rlock() )
								cField := (cAlias)->( Field(i) )
								(cAlias)->&cField := STRTRAN(cFld, cString, cReplace)
							ENDIF
							(cAlias)->( DBunlock() )
						ENDIF
					ENDIF
				Next
			ENDIF
		ELSE
			cField := aColumns[nField-1][1]
			cType := aColumns[nField-1][2]
			IF lFind .AND. cType $ "CND"
				IF (cAlias)->( Rlock() )
					IF cType == "N"
						(cAlias)->&cField := VAL(cReplace)
					ELSEIF cType == "D"
						(cAlias)->&cField := CTOD(cReplace)
					ELSE
						(cAlias)->&cField := cReplace
					ENDIF
				ENDIF
			ENDIF
			(cAlias)->( DBunlock() )
		ENDIF
	ENDIF
	SetProperty( "oWndBase", "Browse_1", "Value", (cAlias)->( RecNo() ) )
	DoMethod( "oWndBase", "Browse_1", 'Refresh' )

Return

*------------------------------------------------------------------------------*
Static Procedure AppendCopy()
*------------------------------------------------------------------------------*
   Local aCurrent

   IF !Empty(cbase)

        go oWndBase.Browse_1.Value
        
	aCurrent := (cbase)->( Scatter() )

	IF (cbase)->( Rlock() )
		(cbase)->( DBappend() )
		(cbase)->( Gather(aCurrent) )
	ENDIF
	(cbase)->( DBunlock() )
	SetProperty( "oWndBase", "Browse_1", "Value", (cbase)->( RecNo() ) )
	DoMethod( "oWndBase", "Browse_1", 'Refresh' )

   ENDIF

Return

*--------------------------------------------------------*
Static Procedure DeleteAll()
*--------------------------------------------------------*
   Local nRecNo

   IF !Empty(cbase)
	nRecNo := (cbase)->( RecNo() )
	(cbase)->( dbGoTop() )
	DO WHILE !(cbase)->( Eof() )
		IF (cbase)->( Rlock() )
			(cbase)->( DBDelete() )
		ENDIF
		(cbase)->( DBskip() )
	ENDDO
	(cbase)->( DBunlock() )
	SetProperty( "oWndBase", "Browse_1", "Value", nRecNo )
	DoMethod( "oWndBase", "Browse_1", 'Refresh' )
        Go top
   ENDIF

Return

*--------------------------------------------------------*
Static Procedure UnDeleteAll()
*--------------------------------------------------------*
   Local nRecNo

   IF !Empty(cbase)
	nRecNo := (cbase)->( RecNo() )
	(cbase)->( dbGoTop() )
	DO WHILE !(cbase)->( Eof() )
		IF (cbase)->( Rlock() )
			(cbase)->( DBRecall() )
		ENDIF
		(cbase)->( DBskip() )
	ENDDO
	(cbase)->( DBunlock() )
	SetProperty( "oWndBase", "Browse_1", "Value", nRecNo )
	DoMethod( "oWndBase", "Browse_1", 'Refresh' )
        Go top
   ENDIF

Return

*-----------------------------------------------------------------------------*
Function Putfile2 ( aFilter, title, cIniFolder, nochangecurdir, cFileName )
*-----------------------------------------------------------------------------*
   local c := '' , n

   Default aFilter := {}, cFileName := ""

   FOR n := 1 TO Len( aFilter )
      c += aFilter[n][1] + Chr(0) + aFilter[n][2] + Chr(0)
   NEXT

Return C_PutFile2 ( c, title, cIniFolder, nochangecurdir, cFileName )


#pragma BEGINDUMP

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"
#include "commctrl.h"

HB_FUNC( CURSORARROW2 )
{
   hb_retnl( (LONG) SetCursor(LoadCursor(NULL, IDC_ARROW)) );
}

HB_FUNC( CURSORWAIT2 )
{
   hb_retnl( (LONG) SetCursor(LoadCursor(NULL, IDC_WAIT)) );
}

HB_FUNC( C_PUTFILE2 )
{
   OPENFILENAME   ofn;
   char           buffer[512];
   char           cExt[4];
   int            flags = OFN_FILEMUSTEXIST | OFN_EXPLORER;

   if( hb_parl(4) )
   {
      flags = flags | OFN_NOCHANGEDIR;
   }

   if( strlen(hb_parc(5)) != 0 )
   {
      strcpy( buffer, hb_parc(5) );
   }
   else
   {
      strcpy( buffer, "" );
   }
   strcpy( cExt, "" );

   memset( ( void * ) &ofn, 0, sizeof(OPENFILENAME) );
   ofn.lStructSize = sizeof( ofn );
   ofn.hwndOwner = GetActiveWindow();
   ofn.lpstrFilter = hb_parc( 1 );
   ofn.lpstrFile = buffer;
   ofn.nMaxFile = 512;
   ofn.lpstrInitialDir = hb_parc( 3 );
   ofn.lpstrTitle = hb_parc( 2 );
   ofn.Flags = flags;
   ofn.lpstrDefExt = cExt;

   if( GetSaveFileName(&ofn) )
   {
      if( ofn.nFileExtension == 0 )
      {
         ofn.lpstrFile = strcat( ofn.lpstrFile, "." );
         ofn.lpstrFile = strcat( ofn.lpstrFile, ofn.lpstrDefExt );
      }

      hb_retc( ofn.lpstrFile );
   }
   else
   {
      hb_retc( "" );
   }
}

#pragma ENDDUMP
