/*
 *
 * MINIGUI - Harbour Win32 GUI library
 * Copyright 2002-2009 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * Program to view DBF files using standard Browse control
 * Miguel Angel Jurez A. - 2009 MigSoft <mig2soft/at/yahoo.com>
 * Includes the code of Grigory Filatov <gfilatov@freemail.ru>
 * and Rathinagiri <srathinagiri@gmail.com>
 *
 */

#include "minigui.ch"
#include "dbuvar.ch"
#include "dbview.ch"

*------------------------------------------------------------------------------*
Function DBUmodistruct(cBase)
*------------------------------------------------------------------------------*

   lModYes           := .F.
   _dbufname         := cBase

   IF !Empty(Alias())

      _DBUoriginalarr := dbstruct()
      _DBUstructarr   := dbstruct()
      _DBUdbfsaved    := .f.

DEFINE WINDOW _DBUcreadbf AT 295 , 312 WIDTH 549 HEIGHT 266 title PROGRAM+VERSION+"- Modify DataBase Table" MODAL nosize nosysmenu

     DEFINE TEXTBOX _DBUfieldname
            ROW    40
            COL    30
            WIDTH  120
            HEIGHT 24
     END TEXTBOX

     DEFINE COMBOBOX _DBUfieldtype
            ROW    40
            COL    160
            WIDTH  120
            HEIGHT 100
            ITEMS {"Character","Numeric","Date","Logical","Memo"}
            VALUE 1
            ON LOSTFOCUS DBUtypelostfocus()
            ON ENTER DBUtypelostfocus()
     END COMBOBOX

     DEFINE LABEL _DBUnamelabel
            ROW    20
            COL    30
            WIDTH  80
            HEIGHT 20
            VALUE "Field"
     END LABEL  

     DEFINE LABEL _DBUtypelabel
            ROW    20
            COL    160
            WIDTH  80
            HEIGHT 20
            VALUE "Type"
     END LABEL

     DEFINE LABEL _DBUsizelabel
            ROW    20
            COL    290
            WIDTH  60
            HEIGHT 20
            VALUE "Size"
     END LABEL  

     DEFINE LABEL _DBUdecimallabel
            ROW    20
            COL    360
            WIDTH  60
            HEIGHT 16
            VALUE "Digits"
     END LABEL

     DEFINE SPINNER _DBUfieldsize
            ROW    40
            COL    290
            WIDTH  60
            HEIGHT 24
            RANGEMIN 1
            RANGEMAX 100
            VALUE 10
            on lostfocus DBUsizelostfocus()
     END SPINNER  

     DEFINE SPINNER _DBUfielddecimals
            ROW    40
            COL    360
            WIDTH  60
            HEIGHT 24
            RANGEMIN 0
            RANGEMAX 99
            on lostfocus DBUdeclostfocus()
     END SPINNER  

    DEFINE BUTTON _DBUaddline
           ROW    40
           COL    430
           WIDTH  80
           HEIGHT 28
           CAPTION "Add"
           action DBUaddstruct()
     END BUTTON  

    DEFINE BUTTON _DBUinsline
           ROW    70
           COL    430
           WIDTH  80
           HEIGHT 28
           CAPTION "Insert"
           action DBUinsstruct()
     END BUTTON

    DEFINE BUTTON _DBUdelline
           ROW    100
           COL    430
           WIDTH  80
           HEIGHT 28
           CAPTION "Delete"
           action DBUdelstruct()
     END BUTTON

     DEFINE GRID _DBUstruct
            ROW    80
            COL    30
            WIDTH  390
            HEIGHT 120
            WIDTHS {145,80,70,70}
            HEADERS {"Name","Type","Size","Decimals"}
            justify {0,0,1,1}
            items _DBUstructarr
            on dblclick DBUlineselected()
     END GRID

    DEFINE BUTTON _DBUsavestruct
           ROW    140
           COL    430
           WIDTH  80
           HEIGHT 28
           CAPTION "Modify"
           action lModYes := DBUmodistructure()
     END BUTTON

    DEFINE BUTTON _DBUexitnew
           ROW    170
           COL    430
           WIDTH  80
           HEIGHT 28
           CAPTION "Exit"
           action lModYes := DBUexitmodidbf()
     END BUTTON

END WINDOW

      center window _DBUcreadbf
      _DBUcreadbf._DBUstruct.deleteallitems()

      for _DBUi := 1 to len(_DBUstructarr)
          do case
             case _DBUstructarr[_DBUi,2] == "C"
               _DBUtype1 := "Character"
             case _DBUstructarr[_DBUi,2] == "N"
               _DBUtype1 := "Numeric"
             case _DBUstructarr[_DBUi,2] == "D"
               _DBUtype1 := "Date"
             case _DBUstructarr[_DBUi,2] == "L"
               _DBUtype1 := "Logical"
             case _DBUstructarr[_DBUi,2] == "M"
               _DBUtype1 := "Memo"
          end case
          _DBUcreadbf._DBUstruct.additem({_DBUstructarr[_DBUi,1],;
                          _DBUtype1,;
           str(_DBUstructarr[_DBUi,3],8,0),;
             str(_DBUstructarr[_DBUi,4],3,0)})
       next _DBUi
       if len(_DBUstructarr) > 0
          _DBUcreadbf._DBUstruct.value := len(_DBUstructarr)
       endif
       activate window _DBUcreadbf
   Endif

return ( lModYes )

*------------------------------------------------------------------------------*
function DBUmodistructure
*------------------------------------------------------------------------------*
if !msgyesno( PadC("C A U T I O N",70)+ CRLF + CRLF +;
              PadC("If you had modified either the field name or the field type,",70) + CRLF +;
              PadC("the data for that fields can not be saved in the modified .DBF",70) + CRLF +;
              PadC("However, a backup file (.BAK) will be created.",70) + CRLF + CRLF +;
              PadC("Are you sure to modify the structure?",70), PROGRAM+VERSION )

   return (.F.)
endif

CursorWait2()

_DBUmodarr := {}
for _DBUi := 1 to len(_DBUstructarr)
   if _DBUi <= len(_DBUoriginalarr)
      _DBUline := ascan(_DBUoriginalarr,{|_DBUx|upper(alltrim(_DBUx[1])) == upper(alltrim(_DBUstructarr[_DBUi,1]))})
      if _DBUline > 0
         if _DBUoriginalarr[_DBUline,2] == _DBUstructarr[_DBUi,2]
            aadd(_DBUmodarr,_DBUi)
         endif
      endif
   endif
next _DBUi
_DBUfname1 := "DBUtemp"
if len(_DBUstructarr) > 0
   _DBUfname1 := "DBUtemp"
   if len(_DBUfname1) > 0
      dbcreate(_DBUfname1,_DBUstructarr)
      close all
      select b
      use &_DBUfname
      select c
      use &_DBUfname1
      select b
      go top
      if len(_DBUmodarr) > 0
         do while .not. eof()
            select c
            append blank
            for _DBUi := 1 to len(_DBUmodarr)
               _DBUfieldname := _DBUstructarr[_DBUmodarr[_DBUi],1]
               replace c->&_DBUfieldname with b->&_DBUfieldname
            next _DBUi
             commit
            select b
            skip
         enddo
      endif
      select b
      close
      select c
      close
      if at(".",_DBUfname) == 0
         _DBUbackname := alltrim(_DBUfname)+".dbf"
         if file(_DBUbackname)
            if file(alltrim(_DBUfname)+".bak")
              ferase(alltrim(_DBUfname)+".bak")
            endif
            frename(_DBUbackname,alltrim(_DBUfname)+".bak")
            frename('DBUtemp.dbf',alltrim(_DBUfname)+".dbf")
            If file('DBUtemp.fpt')
               frename('DBUtemp.fpt',alltrim(_DBUfname)+".fpt")  // MigSoft
            Endif
         endif
      else
         _DBUnewname := substr(alltrim(_DBUfname),1,at(".",_DBUfname)-1)+".bak"
         if file(_DBUfname)
            if file(_DBUnewname)
               ferase(_DBUnewname)
            endif
            frename(_DBUfname,_DBUnewname)
            frename('DBUtemp.dbf',alltrim(_DBUfname))
         endif
      endif
      close all
      use &_DBUfname
      release window _DBUcreadbf
   endif
endif

CursorArrow2()

return (.T.)

*------------------------------------------------------------------------------*
function DBUexitmodidbf
*------------------------------------------------------------------------------*
if len(_DBUstructarr) == 0 .or. _DBUdbfsaved
   release window _DBUcreadbf
   lModYes := .T.
else
   if msgyesno("Are you sure to abort Modifying this dbf?",PROGRAM)
      lModYes := .F.
      release window _DBUcreadbf
   endif
endif
return (lModYes)
